name: Unit tests

on: [push, pull_request]

jobs:
  run:
    runs-on: ${{ matrix.operating-system }}
    continue-on-error: true
    name: Testing PHP ${{ matrix.php-version }} on ${{ matrix.operating-system }}

    strategy:
      matrix:
        operating-system: [ubuntu-latest]
        php-version: ['5.4', '5.5', '5.6', '7.0', '7.1', '7.2', '7.3', '7.4', '8.0', '8.1']

    steps:
      - uses: shivammathur/setup-php@master
        with:
          php-version: ${{ matrix.php-version }}
          coverage: xdebug

      - uses: actions/checkout@v2

      - run: composer validate

      - run: composer install --no-progress

      - run: vendor/bin/phpunit --coverage-clover=tests/coverage.xml

      - uses: codecov/codecov-action@v2
        with:
          token: ${{ secrets.CODECOV_TOKEN }}
          file: tests/coverage.xml
